name: CI

on:
  push:
    branches: [ v3 ]
  pull_request:
    branches: [ v3 ]

jobs:
  test:
    runs-on: ${{ matrix.os }}
    strategy:
      fail-fast: false
      matrix:
        python-version: ["3.7", "3.8", "3.9", "3.10", "3.11"]
        os: [macos-latest, ubuntu-latest]

    steps:
    - name: Checkout code
      uses: actions/checkout@v3

    - name: Set up Python ${{ matrix.python-version }}
      uses: actions/setup-python@v4
      with:
        python-version: ${{ matrix.python-version }}

    - name: Install dependencies
      run: |
        python -m pip install --upgrade pip
        python -m pip install --upgrade setuptools tox wheel

    - name: Build wheel
      run: python setup.py bdist_wheel

    - name: Install from wheel
      run: "python -m pip install --only-binary=:all: ./dist/txt2tags-*.whl"

    - name: Run
      run: |
        txt2tags -t html samples/sample.t2t
        python -m txt2tags -t html samples/sample.t2t

    - name: Run tests
      run: python -m tox -e py

    - name: Check for style issues
      if: ${{ matrix.python-version == 3.11 && matrix.os == 'ubuntu-latest' }}
      run: python -m tox -e style
